#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_with	tests	# unit tests

Summary:	Python tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona sprawdzające zgodność modułu ze standardem kodowania
Name:		pylint
Version:	3.3.5
Release:	1
License:	GPL v2+
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/simple/pylint/
Source0:	https://github.com/PyCQA/pylint/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	44d3c804cae012607fc0b691331d8204
URL:		https://www.pylint.org/
BuildRequires:	python3-devel >= 1:3.7.2
BuildRequires:	python3-modules >= 1:3.7.2
BuildRequires:	python3-setuptools >= 1:62.6
%if %{with tests} || %{with doc}
BuildRequires:	python3-astroid >= 3.3.0
BuildRequires:	python3-astroid < 4.0.0
BuildRequires:	python3-dill >= 0.2
BuildRequires:	python3-isort >= 4.2.5
BuildRequires:	python3-isort < 6
BuildRequires:	python3-mccabe >= 0.6
BuildRequires:	python3-mccabe < 0.8
BuildRequires:	python3-platformdirs >= 2.2.0
%if "%{_ver_lt '%{py3_ver}' '3.11'}" == "1"
BuildRequires:	python3-tomli >= 1.1.0
%endif
BuildRequires:	python3-tomlkit >= 0.10.1
%if "%{_ver_lt '%{py3_ver}' '3.10'}" == "1"
BuildRequires:	python3-typing_extensions >= 3.10.0
%endif
%endif
%if %{with tests}
BuildRequires:	python3-pytest
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.749
%if %{with doc}
BuildRequires:	python3-furo >= 2021.9
BuildRequires:	python3-sphinx_reredirects < 1
BuildRequires:	sphinx-pdg-3 >= 4.5
# >= 5.1.1 when available
%endif
Requires:	py3lint = %{version}-%{release}
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Python tool that checks if a module satisfy a coding standard.

%description -l pl.UTF-8
Narzędzie Pythona sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

%package -n py3lint
Summary:	Python 3 tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania
Group:		Development/Languages/Python
Requires:	python3-pylint = %{version}-%{release}
Obsoletes:	pylint-python3 < 1.0.0-2

%description -n py3lint
Python 3 tool that checks if a module satisfy a coding standard.

Python 3.x version, available via the 'py3lint' command.

%description -n py3lint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Wersja dla Pythona 3.x, dostępna przez polecenie 'py3lint'.

%package -n python3-pylint
Summary:	Python 3 tool that checks if a module satisfy a coding standard (moduły)
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania (modules)
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.7.2

%description -n python3-pylint
Python 3 tool that checks if a module satisfy a coding standard.

This package contains only the Python modules used by the tool.

%description -n python3-pylint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Ten pakiet zawiera tylko moduły Pythona używane przez to narzędzie.

%package doc
Summary:	Documentation for pylint
Summary(pl.UTF-8):	Dokumentacja do pylinta
Group:		Documentation

%description doc
Documentation for pylint.

%description doc -l pl.UTF-8
Dokumentacja do pylinta.

%prep
%setup -q

# stub for setuptools
cat >setup.py <<EOF
from setuptools import setup
setup()
EOF

# disable errors on warnings caused by unreachable network
%{__sed} -i -e '/ALLSPHINXOPTS/ s/ -W / /' doc/Makefile

%build
%py3_build

%if %{with doc}
%{__make} -C doc html \
	PYTHONPATH=$PWD \
	PIP=/bin/true \
	PYLINT_SPHINX_FATAL_WARNINGS= \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sysconfdir}

%py3_install

for tool in pylint pylint-config pyreverse symilar ; do
	%{__mv} $RPM_BUILD_ROOT%{_bindir}/${tool} $RPM_BUILD_ROOT%{_bindir}/${tool}-3
	ln -s ${tool}-3 $RPM_BUILD_ROOT%{_bindir}/${tool}
done
# old PLD package compatibility
ln -s pylint-3 $RPM_BUILD_ROOT%{_bindir}/py3lint
ln -s pyreverse-3 $RPM_BUILD_ROOT%{_bindir}/py3reverse

cp -p examples/pylintrc $RPM_BUILD_ROOT%{_sysconfdir}/pylintrc

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pylint
%attr(755,root,root) %{_bindir}/pylint-config
%attr(755,root,root) %{_bindir}/pyreverse
%attr(755,root,root) %{_bindir}/symilar

%files -n py3lint
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pylint-3
%attr(755,root,root) %{_bindir}/pylint-config-3
%attr(755,root,root) %{_bindir}/pyreverse-3
%attr(755,root,root) %{_bindir}/symilar-3
%attr(755,root,root) %{_bindir}/py3lint
%attr(755,root,root) %{_bindir}/py3reverse
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc

%files -n python3-pylint
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt README.rst examples
%{py3_sitescriptdir}/pylint
%{py3_sitescriptdir}/pylint-%{version}-py*.egg-info

%if %{with doc}
%files doc
%defattr(644,root,root,755)
%doc doc/_build/html/*
%endif
%changelog
* Mon Mar 17 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pylint.git;a=log;h=auto/th/pylint-3.3.5-1

* Mon Mar 17 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> bf14f11
- Up to 3.3.5

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 558c306
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 5b1692f
- python 3.13 rebuild

* Sun Sep 18 2022 Jakub Bogusz <qboosh@pld-linux.org> 987f14f
- disable sphinx -W option to allow build without network; release 2

* Wed Sep 14 2022 Jakub Bogusz <qboosh@pld-linux.org> fdba914
- updated to 2.15.2

* Mon Apr 04 2022 Jan Rękorajski <baggins@pld-linux.org> db91902
- Release 3 (by relup.sh)

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 5c33100
- rebuild with python 3.10

* Mon Mar 21 2022 Jakub Bogusz <qboosh@pld-linux.org> b9af353
- updated dependencies

* Wed Dec 15 2021 Jakub Bogusz <qboosh@pld-linux.org> 4ccf643
- setuptools epoch

* Wed Dec 08 2021 Jan Palus <atler@pld-linux.org> 966cfc1
- up to 2.12.2

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> f8bbbbb
- fix docs build

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> da7eaa4
- drop conflictiong dependencies

* Wed Mar 03 2021 Jan Rękorajski <baggins@pld-linux.org> 3de3201
- up to 2.7.2

* Sun Mar 29 2020 Jakub Bogusz <qboosh@pld-linux.org> 9b3953e
- added deps patch: fix python_requires (broke distlib: '.*' not allowed for '>=' constraints)
- release 2

* Sat Nov 16 2019 Jakub Bogusz <qboosh@pld-linux.org> 2a5c34f
- updated dependencies

* Sat Nov 16 2019 Jakub Bogusz <qboosh@pld-linux.org> b50e511
- updated to 2.4.4
- package binaries with -3 suffix (as commonly packaged by others) in py3lint package
- base pylint package is a wrapper for py3lint with standard binary names

* Sun Nov 03 2019 Jan Rękorajski <baggins@pld-linux.org> a6607fb
- updated BRs
- rel 3

* Mon Oct 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 9101e20
- updated dependencies; now requires python 3.5+ (separate spec with pylint 1.9.x for python2 pending)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> e1a36fc
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 20 2019 Adam Gołębiowski <adamg@pld-linux.org> b0e6a31
- updated to 2.4.3

